// Generated by dts-bundle-generator v5.4.0

/// <reference types="mocha" />
/// <reference types="papaparse" />
/// <reference types="prop-types" />
/// <reference types="react" />

export interface CustomizablePapaParseConfig {
	delimiter?: Papa.ParseConfig["delimiter"];
	newline?: Papa.ParseConfig["newline"];
	quoteChar?: Papa.ParseConfig["quoteChar"];
	escapeChar?: Papa.ParseConfig["escapeChar"];
	comments?: Papa.ParseConfig["comments"];
	skipEmptyLines?: Papa.ParseConfig["skipEmptyLines"];
	delimitersToGuess?: Papa.ParseConfig["delimitersToGuess"];
}
export declare type BaseRow = {
	[name: string]: unknown;
};
export declare type ParseCallback<Row extends BaseRow> = (rows: Row[], info: {
	startIndex: number;
}) => void | Promise<void>;
export interface ImporterPreviewColumn {
	index: number;
	header?: string;
	values: string[];
}
export interface ImporterFilePreview {
	rawData: string;
	columns: ImporterPreviewColumn[];
	skipHeaders: boolean;
	parseWarning?: Papa.ParseError;
}
export interface ImportInfo {
	file: File;
	preview: ImporterFilePreview;
	fields: string[];
	columnFields: (string | undefined)[];
}
export declare type ImporterContentRenderProp = (info: {
	file: File | null;
	preview: ImporterFilePreview | null;
}) => React.ReactNode;
export interface ImporterFieldProps {
	name: string;
	label: string;
	optional?: boolean;
}
export interface ImporterProps<Row extends BaseRow> extends CustomizablePapaParseConfig {
	chunkSize?: number;
	assumeNoHeaders?: boolean;
	restartable?: boolean;
	processChunk: ParseCallback<Row>;
	onStart?: (info: ImportInfo) => void;
	onComplete?: (info: ImportInfo) => void;
	onClose?: (info: ImportInfo) => void;
	children?: ImporterContentRenderProp | React.ReactNode;
}
export declare const ImporterField: React.FC<ImporterFieldProps>;
export declare function Importer<Row extends BaseRow>({ chunkSize, assumeNoHeaders, restartable, processChunk, onStart, onComplete, onClose, children: content, ...customPapaParseConfig }: React.PropsWithChildren<ImporterProps<Row>>): React.ReactElement;

export {};
